

function SlideStep0()
	API_Log("**************step1")
	API_StartGameTutorial("blocking", "slideItem")
--	API_ShowTextBox("tutorial_slide_row_01")
	API_AddInputFilterArea(0, 0, 7, 9)
 	API_EnableMaskTiles("false", 0, 2, 0, 5)
  	API_EnableMaskTiles("false", 0, 4, 2, 4)
  	--	API_HighlightItems("2,2")
 	API_ShowArrowAnimation(0, 5, 0, 4)
end

function SlideStep1()
	API_Log("**************step2")
	API_StartGameTutorial("blocking", "slideItem")
	--API_ShowTextBox("tutorial_slide_row_01")
		API_AddInputFilterArea(0, 0, 7, 9)
	API_EnableMaskTiles("false", 6, 3, 6, 6)
	API_EnableMaskTiles("false", 5, 4, 7, 4)
	--	API_HighlightItems("2,2")
	API_ShowArrowAnimation(6, 3, 6, 4)
end

function onTutorialFinished()
	if tutorialStep == 0 and continue == true then
        SlideStep1()
        tutorialStep = 1
    end
end 

function ShowYouHaveDoneGreat()
	API_Log("**************step2")

--	API_StartGameTutorial("blocking", "anyTouch")
	API_EnableGlobalMasking("false")
--  API_ShowTextBox("tutorial_congratulation")
--	API_SetAllowedSliding("all")
	API_EnableHint("true")
	API_EndTutorial()
end


function onInit()
	API_EnableHint("false")
	API_Log("**************onInit TUTORIAL")
	API_Log("**************BOARD NUM_TILES_X:" .. NUM_TILES_X)
	API_Log("**************BOARD NUM_TILES_Y:" .. NUM_TILES_Y)
	SlideStep0()
	tutorialStep = 0
	EXPECTED_MATCH_STEP_0 = {16,24,32,33,34}
	EXPECTED_MATCH_STEP_1 = {37,38,39,46,54}
	--EXPECTED_MATCH_STEP_3 = {41,49,57}
	--EXPECTED_MATCH_STEP_4 = {55,62,70}
	continue = true
	onMatchProcess = true
	API_Log(table.tostring(EXPECTED_MATCH_STEP_1))
	API_Log(table.tostring(EXPECTED_MATCH_STEP_2))
	--API_Log(table.tostring(EXPECTED_MATCH_STEP_3))
	--API_Log(table.tostring(EXPECTED_MATCH_STEP_4))
	--API_AddItemsToSpawnerBuffer("normal:blue,normal:yellow,normal:red,normal:red,normal:yellow,normal:blue,normal:orange,normal:red,normal:pink");
end


function onEndTurn()
	API_Log("**************onEndTurn (tutorialStep = " .. tutorialStep .. ")")
	if continue == true then
		onMatchProcess = true
		if tutorialStep == 1 then
			API_Log("**************Going to SlideStep2")
			SlideStep2()
			tutorialStep = 2
		elseif tutorialStep == 2 then
			API_Log("**************Going to SlideStep3")
			tutorialStep = 3
			SlideStep3()
			ShowYouHaveDoneGreat()
		end
	end
end

function onMatch(matchTiles)
	if continue == true and onMatchProcess == true then
		tiles = {}
		API_Log("**************onMatch (tutorialStep = ".. tutorialStep .. ") Matching tiles:" .. matchTiles)
		tiles = getTilesFromMatchString(matchTiles)
		API_Log("************** Going to compare...")
		API_Log("************ TABLE tiles:" .. table.tostring(tiles))
		if tutorialStep == 0 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_0:"  .. table.tostring(EXPECTED_MATCH_STEP_0))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_0, tiles)
		elseif tutorialStep == 1 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_1:"  .. table.tostring(EXPECTED_MATCH_STEP_1))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_1, tiles)
		elseif tutorialStep == 2 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_2:"  .. table.tostring(EXPECTED_MATCH_STEP_2))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_2, tiles)
		elseif tutorialStep == 3 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_3:"  .. table.tostring(EXPECTED_MATCH_STEP_3))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_3, tiles)
		elseif tutorialStep == 4 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_4:"  .. table.tostring(EXPECTED_MATCH_STEP_4))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_4, tiles)
		end
		if (continue == true) then
			API_Log("************ continue !!!")
			onMatchProcess = false
		else
			API_Log("************ NO continue !!!")
			API_EnableHint("true")
		end
		if tutorialStep < 6 then
			API_EndTutorial()
		end
	end
end

function getTilesFromMatchString(matchingTiles)
	tilesFromMatch = {}
	for tileIndex in matchingTiles:gmatch("([%d%.%+%-]+),?") do
		tilesFromMatch[#tilesFromMatch + 1] = tonumber(tileIndex)
	end
	return tilesFromMatch;
end

function IsExpectedMatch(expectedMatch, matchReceived)
	return equals(expectedMatch, matchReceived, false);
end

-----------------------------

-- function SlideStep0()
-- 	API_Log("**************step0")
--     API_StartGameTutorial("blocking", "makeAnL")

-- 	API_AddInputFilterArea(0, 0, 7, 9)
-- 	API_EnableMaskTiles("false", 0, 2, 0, 5)
--  	API_EnableMaskTiles("false", 0, 4, 2, 4)
-- 	API_ShowArrowAnimation(0, 5, 0, 4)
-- end

-- function onTutorialFinished()
-- 	if tutorialStep == 0 then
--         SlideStep1()
--         tutorialStep = 1
--     end
-- end 

-- function SlideStep1()
-- 	API_Log("**************step1")
-- 	API_StartGameTutorial("blocking", "makeAT")

-- 	API_AddInputFilterArea(0, 0, 7, 9)
-- 	API_EnableMaskTiles("false", 6, 3, 6, 6)
-- 	API_EnableMaskTiles("false", 5, 4, 7, 4)
-- 	API_ShowArrowAnimation(6, 3, 6, 4)
-- end


-- function onInit()
-- 	API_EnableHint("false")
-- 	API_Log("**************onInit TUTORIAL")
-- 	API_Log("**************BOARD NUM_TILES_X:" .. NUM_TILES_X)
-- 	API_Log("**************BOARD NUM_TILES_Y:" .. NUM_TILES_Y)
-- 	SlideStep0()
-- 	tutorialStep = 0
-- 	EXPECTED_MATCH_STEP_1 = {23,24,25}
-- 	EXPECTED_MATCH_STEP_2 = {59,60,61}
-- 	--EXPECTED_MATCH_STEP_3 = {41,49,57}
-- 	--EXPECTED_MATCH_STEP_4 = {55,62,70}
-- 	continue = true
-- 	onMatchProcess = true
-- 	API_Log(table.tostring(EXPECTED_MATCH_STEP_1))
-- 	API_Log(table.tostring(EXPECTED_MATCH_STEP_2))
-- 	--API_Log(table.tostring(EXPECTED_MATCH_STEP_3))
-- 	--API_Log(table.tostring(EXPECTED_MATCH_STEP_4))
-- 	--API_AddItemsToSpawnerBuffer("normal:blue,normal:yellow,normal:red,normal:red,normal:yellow,normal:blue,normal:orange,normal:red,normal:pink");
-- end


-- function onEndTurn()
-- 	API_Log("**************onEndTurn (tutorialStep = " .. tutorialStep .. ")")
-- 	if continue == true then
-- 		onMatchProcess = true
-- 		if tutorialStep == 0 then
-- 			API_Log("**************Going to SlideStep2")
-- 			SlideStep1()
-- 			tutorialStep = 1
-- 		end
-- 	end
-- end

-- function onMatch(matchTiles)
-- 	if continue == true and onMatchProcess == true then
-- 		tiles = {}
-- 		API_Log("**************onMatch (tutorialStep = ".. tutorialStep .. ") Matching tiles:" .. matchTiles)
-- 		tiles = getTilesFromMatchString(matchTiles)
-- 		API_Log("************** Going to compare...")
-- 		API_Log("************ TABLE tiles:" .. table.tostring(tiles))
-- 		if tutorialStep == 1 then
-- 			API_Log("************ TABLE EXPECTED_MATCH_STEP_1:"  .. table.tostring(EXPECTED_MATCH_STEP_1))
-- 			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_1, tiles)
-- 		elseif tutorialStep == 2 then
-- 			API_Log("************ TABLE EXPECTED_MATCH_STEP_2:"  .. table.tostring(EXPECTED_MATCH_STEP_2))
-- 			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_2, tiles)
-- 		elseif tutorialStep == 3 then
-- 			API_Log("************ TABLE EXPECTED_MATCH_STEP_3:"  .. table.tostring(EXPECTED_MATCH_STEP_3))
-- 			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_3, tiles)
-- 		elseif tutorialStep == 4 then
-- 			API_Log("************ TABLE EXPECTED_MATCH_STEP_4:"  .. table.tostring(EXPECTED_MATCH_STEP_4))
-- 			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_4, tiles)
-- 		end
-- 		if (continue == true) then
-- 			API_Log("************ continue !!!")
-- 			onMatchProcess = false
-- 		else
-- 			API_Log("************ NO continue !!!")
-- 			API_EnableHint("true")
-- 		end
-- 		if tutorialStep < 6 then
-- 			API_EndTutorial()
-- 		end
-- 	end
-- end

-- function getTilesFromMatchString(matchingTiles)
-- 	tilesFromMatch = {}
-- 	for tileIndex in matchingTiles:gmatch("([%d%.%+%-]+),?") do
-- 		tilesFromMatch[#tilesFromMatch + 1] = tonumber(tileIndex)
-- 	end
-- 	return tilesFromMatch;
-- end

-- function IsExpectedMatch(expectedMatch, matchReceived)
-- 	return equals(expectedMatch, matchReceived, false);
-- end




-------------------------------------------------------






-- function SlideStep0()
--     --API_StartGameTutorial("blocking", "showAnimation")
--     --API_LoadArbitraryXML("art/scenes/animated_tutorial/tutorial_animated_row.xml","locatorForAnimatedTutorial")
-- 	SlideStep1()
-- end

-- function onTutorialFinished()
-- 	--if tutorialStep == 0 then
--     --    SlideStep1()
--     --    tutorialStep = 1
--     --end
-- end 

-- function SlideStep1()
-- 	API_Log("**************step1")
-- 	API_StartGameTutorial("blocking", "slideItem")
-- --	API_ShowTextBox("tutorial_slide_row_01")
-- 	API_AddInputFilterArea(0, 0, 7, 9)
-- 	API_EnableMaskTiles("false", 1, 3, 4, 3)
--  	API_EnableMaskTiles("false", 2, 4, 2, 5)
-- --	API_HighlightItems("2,2")
-- 	API_ShowArrowAnimation(1, 3, 2, 3)
-- end

-- function onInit()
-- 	API_EnableHint("false")
-- 	API_Log("**************onInit TUTORIAL")
-- 	API_Log("**************BOARD NUM_TILES_X:" .. NUM_TILES_X)
-- 	API_Log("**************BOARD NUM_TILES_Y:" .. NUM_TILES_Y)
-- 	SlideStep0()
-- 	tutorialStep = 1
-- 	EXPECTED_MATCH_STEP_1 = {41,42,43,44,45}
-- 	continue = true
-- 	onMatchProcess = true
-- 	API_Log(table.tostring(EXPECTED_MATCH_STEP_1))
-- 	--API_AddItemsToSpawnerBuffer("normal:blue,normal:yellow,normal:red,normal:red,normal:yellow,normal:blue,normal:orange,normal:red,normal:pink");
-- end


-- function onEndTurn()
-- 	API_Log("**************onEndTurn (tutorialStep = " .. tutorialStep .. ")")
-- 	if continue == true then
-- 		onMatchProcess = true
-- 		if tutorialStep == 1 then
-- 			API_Log("**************end tutorial")					
-- 		end
-- 	end
-- end

-- function onMatch(matchTiles)
-- 	if continue == true and onMatchProcess == true then
-- 		tiles = {}
-- 		API_Log("**************onMatch (tutorialStep = ".. tutorialStep .. ") Matching tiles:" .. matchTiles)
-- 		tiles = getTilesFromMatchString(matchTiles)
-- 		API_Log("************** Going to compare...")
-- 		API_Log("************ TABLE tiles:" .. table.tostring(tiles))
-- 		if tutorialStep == 1 then
-- 			API_Log("************ TABLE EXPECTED_MATCH_STEP_1:"  .. table.tostring(EXPECTED_MATCH_STEP_1))
-- 			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_1, tiles)		
-- 		end
-- 		if (continue == true) then
-- 			API_Log("************ continue !!!")
-- 			onMatchProcess = false
-- 		else
-- 			API_Log("************ NO continue !!!")
-- 			API_EnableHint("true")
-- 		end
-- 		if tutorialStep < 6 then
-- 			API_EndTutorial()
-- 		end
-- 	end
-- end

-- function getTilesFromMatchString(matchingTiles)
-- 	tilesFromMatch = {}
-- 	for tileIndex in matchingTiles:gmatch("([%d%.%+%-]+),?") do
-- 		tilesFromMatch[#tilesFromMatch + 1] = tonumber(tileIndex)
-- 	end
-- 	return tilesFromMatch;
-- end

-- function IsExpectedMatch(expectedMatch, matchReceived)
-- 	return equals(expectedMatch, matchReceived, false);
-- end